
local LootsTab =  {}
_G["LootsTab"] = LootsTab

local AceGUI = LibStub("AceGUI-3.0")

local count = 0

function DrawLootTab()

	tableUnit = ClassicRaidAssist:getLootTabs()
	
    local fullTab = AceGUI:Create("SimpleGroup")
    fullTab:SetWidth(400)
    fullTab:SetLayout("Flow")
	
	count = 0
	
    for key, value in pairs(tableUnit) do
		
		count = count + 1
		
		local playerContainer = AceGUI:Create("InlineGroup")
		--playerContainer:SetWidth(300)
        playerContainer:SetLayout("Flow")
        playerContainer:SetFullWidth(true)

		local currData = AceGUI:Create("Label")
		currData:SetWidth(60)						
		currData:SetText("|cffff0000" .. value['data'])			
		playerContainer:AddChild(currData)
		
		local currName = AceGUI:Create("Label")
        currName:SetWidth(150)
        currName:SetText(value['name'])
		playerContainer:AddChild(currName)
			
		local currDataLoot = AceGUI:Create("Label")
        currDataLoot:SetWidth(150)
        currDataLoot:SetText("Дата осмотра : |cff228B22" .. value['dataloot'])
		playerContainer:AddChild(currDataLoot)
		
		local currLoot = AceGUI:Create("Label")
		currLoot:SetWidth(400)						
		currLoot:SetText(value['loot'])			
		playerContainer:AddChild(currLoot)	
		
		playerContainer:SetTitle(value['npc'])
		
        fullTab:AddChild(playerContainer)
	
	end
	
    return fullTab

end

function LootsTab:DrawLoots(container)

	ClassicRaidAssist:ClearCooldowns()
	
	local bottomNote = AceGUI:Create("Label")
    bottomNote:SetFullWidth(true)
    bottomNote:SetText("Данная страница содержит последнюю добычу группы. При перезагрузке очищается.")
    container:AddChild(bottomNote)
	
	local buttonContainer = AceGUI:Create("SimpleGroup")
    buttonContainer:SetFullWidth(true)
    buttonContainer:SetLayout("Flow")
	
	local viewBtn = AceGUI:Create("Button")
    viewBtn:SetText("Обновить")
    viewBtn:SetWidth(200)
    if not (IsInGroup() or IsInRaid()) then
        viewBtn:SetDisabled(true)
        viewBtn:SetText("Обновить")
    end
    viewBtn:SetCallback("OnClick", function()
        container:ReleaseChildren()
        ClassicRaidAssist.db.char.lootsContainer = container		
        LootsTab:DrawLoots(container)
    end)	
	buttonContainer:AddChild(viewBtn)
	
	tableLoot = DrawLootTab()
	
	local viewBtn = AceGUI:Create("Button")
    viewBtn:SetText("Очистить (" .. count .. ")")
    viewBtn:SetWidth(200)
    if not (IsInGroup() or IsInRaid()) then
        viewBtn:SetDisabled(true)
        viewBtn:SetText("Очистить")
    end
    viewBtn:SetCallback("OnClick", function()
        container:ReleaseChildren()
        ClassicRaidAssist.db.char.lootsContainer = container
		ClassicRaidAssist:clearLootTabs()
        LootsTab:DrawLoots(container)
    end)
	
	buttonContainer:AddChild(viewBtn)
	
	container:AddChild(buttonContainer)
	
	local scrollContainer = AceGUI:Create("SimpleGroup")
    scrollContainer:SetFullWidth(true)
    scrollContainer:SetHeight(310)
    scrollContainer:SetLayout("Fill")

    local scroll = AceGUI:Create("ScrollFrame")
    scroll:SetLayout("Flow")
    scroll:AddChild(tableLoot)
    
	scrollContainer:AddChild(scroll)
	
	container:AddChild(scrollContainer)
	
    local bottomNote = AceGUI:Create("Label")
    bottomNote:SetFullWidth(true)
    bottomNote:SetText("Каждый в рейде должен иметь аддон.")
    container:AddChild(bottomNote)
	
end


