
local SpellControlTab =  {}
_G["SpellControlTab"] = SpellControlTab

local AceGUI = LibStub("AceGUI-3.0")

local frame = nil

cooldowns = {}
statuses = {}
tooltips = {}
tableEnegry = {}
					
function DrawSpellTab()
	
    local fullTab = AceGUI:Create("SimpleGroup")
    fullTab:SetWidth(400)
    fullTab:SetLayout("Flow")
	
    for key, value in pairs(ClassicRaidAssist.db.char.spellControlManualList) do
		
		if value ~= nil then
			locClass, englishClass, locRace = GetPlayerInfoByGUID(key)				

			if locClass == nil then
				return fullTab 
			end	
		
			local tempCheckBox = AceGUI:Create("CheckBox")
			tempCheckBox:SetWidth(300)
			tempCheckBox:SetLabel("|c" .. RAID_CLASS_COLORS[englishClass].colorStr .. value["name"] .. "|r (" .. locRace .. ", " .. locClass .. ")")
			tempCheckBox:SetValue(value["check"])
			tempCheckBox:SetCallback("OnValueChanged", function() ClassicRaidAssist.db.char.spellControlManualList[key]["check"] = not ClassicRaidAssist.db.char.spellControlManualList[key]["check"] end)
		
			fullTab:AddChild(tempCheckBox)
		
		end		
			
	end
	
    return fullTab

end

function scanRaid()
		
	if IsInRaid() then
		key = "raid"
	elseif IsInGroup() then
		key = "party"
	else
		return ""
	end
	
	local players = GetNumGroupMembers()

	for groupindex = 1,players do
		
		local name = UnitName(key..groupindex)
		local guid = UnitGUID(key..groupindex)
		
		if ClassicRaidAssist.db.char.spellControlManualList[guid] == nil then
			local id = select(3, UnitClass(key..groupindex))
			if (id == 2 or id == 5 or id == 11 or id == 7) then
				ClassicRaidAssist.db.char.spellControlManualList[guid] = {name = name, check = false}
				SpellControlTab:setStatusUnit(name, 0)
			end
		end
	end
		
end

local function SelectGroup(container, event, group)

	container:ReleaseChildren()
    ClassicRaidAssist.db.char.currentSpellControlTab = group
    if group == "heal" then
        DrawSpellControlHeal(container)
	--elseif group == "targetdebuff" then
		--TargetDebuffTab:DrawTargetDebuffTab(container)	
    end
end

function SpellControlTab:DrawSpellControl(container)

	ClassicRaidAssist:ClearCooldowns()
	
	tabGroup = AceGUI:Create("TabGroup")
    
    tabGroup:SetTabs({
        {value = "heal", text = "Хилы" },
		--{value = "targetdebuff", text = "Дебафы цели" },
    })

	tabGroup:SetWidth(410)
    tabGroup:SetCallback("OnGroupSelected", SelectGroup)
    tabGroup:SelectTab(ClassicRaidAssist.db.char.currentSpellControlTab)
    container:AddChild(tabGroup)		
	
end

function DrawSpellControlHeal(container)
	
	ClassicRaidAssist:ClearCooldowns()
		
	local groupContainer = AceGUI:Create("SimpleGroup")
    groupContainer:SetFullWidth(true)
	
	tabGroup:SetHeight(200)
	
    groupContainer:SetLayout("Flow")
	
	local viewBtn = AceGUI:Create("Button")
    viewBtn:SetText("Заполнить список (авто)")
    viewBtn:SetWidth(200)
    viewBtn:SetCallback("OnClick", function()
        				
		scanRaid()
		container:ReleaseChildren()
        ClassicRaidAssist.db.char.spellControlContainer = container
        DrawSpellControlHeal(container)
		
    end)
	
	groupContainer:AddChild(viewBtn)
	
	local viewBtn = AceGUI:Create("Button")
    viewBtn:SetText("Добавить в список цель")
    viewBtn:SetWidth(180)
    viewBtn:SetCallback("OnClick", function()
        
		local name = UnitName("target")
		local guid = UnitGUID("target")
		
		ClassicRaidAssist.db.char.spellControlManualList[guid] = {name = name, check = true}		
		SpellControlTab:setStatusUnit(name, 0)
		
		container:ReleaseChildren()
        ClassicRaidAssist.db.char.spellControlContainer = container
        DrawSpellControlHeal(container)
		
    end)
	
	groupContainer:AddChild(viewBtn)
		
	local viewBtn = AceGUI:Create("Button")
    viewBtn:SetText("Очистить список")
    viewBtn:SetWidth(200)
    viewBtn:SetCallback("OnClick", function()
        container:ReleaseChildren()
        ClassicRaidAssist.db.char.spellControlContainer = container
		ClassicRaidAssist.db.char.spellControlManualList = {}
		cooldowns = {}
		statuses = {}
		tableEnegry = {}
        DrawSpellControlHeal(container)
    end)

	groupContainer:AddChild(viewBtn)

	local viewBtn = AceGUI:Create("Button")
    viewBtn:SetText("Сбросить кэш заклинаний")
    viewBtn:SetWidth(180)
    viewBtn:SetCallback("OnClick", function()
		cooldowns = {}
		tableEnegry = {}
    end)

	groupContainer:AddChild(viewBtn)	
	
	local viewBtn = AceGUI:Create("Button")
    viewBtn:SetText("Открыть окно монитора")
    viewBtn:SetWidth(200)
    viewBtn:SetCallback("OnClick", function()
        SpellControlTab:Toggle()
    end)
	
	groupContainer:AddChild(viewBtn)
	
	local itemHealScanMonitorCheckBox = AceGUI:Create("CheckBox")
	itemHealScanMonitorCheckBox:SetWidth(180)
    itemHealScanMonitorCheckBox:SetValue(ClassicRaidAssist.db.char.spellControlHealScanMonitorEnable)
    itemHealScanMonitorCheckBox:SetLabel("Активировать монитор")
    itemHealScanMonitorCheckBox:SetCallback("OnValueChanged", function() ClassicRaidAssist.db.char.spellControlHealScanMonitorEnable = not ClassicRaidAssist.db.char.spellControlHealScanMonitorEnable end)

    groupContainer:AddChild(itemHealScanMonitorCheckBox)
		
	container:AddChild(groupContainer)
	
	local scrollContainer = AceGUI:Create("InlineGroup")
    scrollContainer:SetTitle("Список хилов:")
	scrollContainer:SetWidth(390)
	scrollContainer:SetHeight(220)	   
    scrollContainer:SetLayout("Fill")

    local scroll = AceGUI:Create("ScrollFrame")
    scroll:SetLayout("Flow")				
    scroll:AddChild(DrawSpellTab())
	
	scrollContainer:AddChild(scroll)
	container:AddChild(scrollContainer)
	
end

function SpellControlTab:Toggle()
    if(frame:IsShown()) then
        frame:Hide()
    else
        frame:Show()
    end
end

function SpellControlTab:DrawSpellControlFrame(container)
	
	frame = container
		
	AutoReDrowSpellFrame()
	
end

	
--Обновление окна производится раз в секунду. Данные по мане зависят от расстояния до игрока. 
--Если больше 100 м задержка 5 сек (особенность API). Статус активности расчитываются по расходу манны
--Использование расходников фиксируется в пределах 50 м, для величения радиуса другие игроки должны установить аддон						
			
function DrawSpellControlFullTab(container)
	
	local fullTab = AceGUI:Create("SimpleGroup")
    fullTab:SetFullWidth(true)
	--fullTab:SetWidth(450)
	--fullTab:SetHeight(200)
    fullTab:SetLayout("Fill")
	
	-- zagolovok
	
	local zContainer = AceGUI:Create("SimpleGroup")
	--zContainer:SetWidth(400)
	zContainer:SetFullWidth(true)
	zContainer:SetLayout("Flow")
			
	local Label = AceGUI:Create("Label")
	Label:SetWidth(115)
	Label:SetText("Имя игрока")

	zContainer:AddChild(Label)

	local Label = AceGUI:Create("Label")
	Label:SetWidth(40)
	Label:SetText("Мана")
	zContainer:AddChild(Label)
	
	local Label = AceGUI:Create("Label")
	Label:SetWidth(50)
	Label:SetText("Простой")
	zContainer:AddChild(Label)

	local Label = AceGUI:Create("Label")
	Label:SetWidth(50)
	Label:SetText("Бутылка")
	zContainer:AddChild(Label)
	
	local Label = AceGUI:Create("Label")
	Label:SetWidth(40)
	Label:SetText("Рунка")
	zContainer:AddChild(Label)
	
	local Label = AceGUI:Create("Label")
	Label:SetWidth(50)
	Label:SetText("Статус")
	zContainer:AddChild(Label)
	
	container:AddChild(zContainer)		
	
	local scrollContainer = AceGUI:Create("ScrollFrame")
    scrollContainer:SetLayout("Flow")
		
	local total= 0
	local totalMax = 0
	local totalpersentage = 0
	
	num = 1
	for key, value in pairs(ClassicRaidAssist.db.char.spellControlManualList) do

		if value["check"] then
			
			num = num + 1
			
			local groupContainer = AceGUI:Create("SimpleGroup")
			groupContainer:SetFullWidth(true)
			--groupContainer:SetWidth(450)
			groupContainer:SetLayout("Flow")
	
			_, englishClass = GetPlayerInfoByGUID(key)
			
			if englishClass == nil then
				englishClass = "PRIEST"
			end
	
			local nameLabel = AceGUI:Create("InteractiveLabel")
			nameLabel:SetWidth(100)
			nameLabel:SetText("|c" .. RAID_CLASS_COLORS[englishClass].colorStr .. value["name"])
			groupContainer:AddChild(nameLabel)
			nameLabel:SetCallback("OnEnter", function()
				
				if(tooltips[value["name"]] == nil) then
					tooltips[value["name"]] = CreateFrame("GameTooltip", "SpellControllHealName" .. value["name"], nil, "GameTooltipTemplate" )
				end
				MyToolTip = tooltips[value["name"]]
				MyToolTip:SetOwner(WorldFrame, "ANCHOR_CURSOR")	
	
				ltable = tableEnegry[value["name"]]
				if ltable ~= nil then
					for i = 1, ClassicRaidAssist.db.char.maxNumTableEnergy do
					--for key, value in pairs(tableEnegry[value["name"]]) do						
						lvalue = ltable[ClassicRaidAssist.db.char.maxNumTableEnergy - i - 1]
						if lvalue ~= nil then
							MyToolTip:AddLine(lvalue["fdata"] .. " восстановленно " .. lvalue["value"], 1, 1, 1) -- , 1, .82, 0, true)
						end						
					end					
				end
				MyToolTip:Show()
				
			end)
			nameLabel:SetCallback("OnLeave", function() 
				MyToolTip:Hide()
			end)
		
			local spacerIcon = AceGUI:Create("Icon")
			--spacerIcon.image:SetAllPoints()
			spacerIcon:SetWidth(16)
			spacerIcon:SetHeight(16)
			--spacerIcon:SetImage("Interface\\Icons\\spell_frost_stun")
			groupContainer:AddChild(spacerIcon)
		
			local mana = UnitPower(value["name"],0)
			local manaMax = UnitPowerMax(value["name"],0)
			local persentage = 0
		
			if manaMax ~= 0 then 
				persentage = (100*(mana/manaMax))
			end	
					
			total = total + mana
			totalMax = totalMax + manaMax	
			
			local manaLabel = AceGUI:Create("Label")
			manaLabel:SetWidth(40)
			manaLabel:SetText(getFormatedPersentage(persentage))
			groupContainer:AddChild(manaLabel)
					
			local activityLabel = AceGUI:Create("Label")
			activityLabel:SetWidth(50)
			activityLabel:SetText(getActivityAndSetStatus(key, value["name"]))
			groupContainer:AddChild(activityLabel)
			
			local manaSpellIcon = AceGUI:Create("Icon")
			manaSpellIcon.image:SetAllPoints()
			manaSpellIcon:SetWidth(16)
			manaSpellIcon:SetHeight(16)
			groupContainer:AddChild(manaSpellIcon)
			
			local manaSpellLabel = AceGUI:Create("Label")
			manaSpellLabel:SetWidth(35)
			manaSpellLabel:SetText("   ")
			groupContainer:AddChild(manaSpellLabel)
			
			local runeSpellIcon = AceGUI:Create("Icon")
			runeSpellIcon.image:SetAllPoints()
			runeSpellIcon:SetWidth(16)
			runeSpellIcon:SetHeight(16)
			groupContainer:AddChild(runeSpellIcon)
			
			local runeSpellLabel = AceGUI:Create("Label")
			runeSpellLabel:SetWidth(20)
			runeSpellLabel:SetText("   ")
			groupContainer:AddChild(runeSpellLabel)
			
			local stateLabel = AceGUI:Create("Label")
			stateLabel:SetWidth(60)
			groupContainer:AddChild(stateLabel)
									
			if cooldowns[key] ~= nill then
				
				for ckey, cvalue in pairs(cooldowns[key]) do			
																	
					--if ckey == "Activity" then
																			
					--	local activity = math.floor(GetTime() - cvalue["data"])
							
					--	if activity > 0 then
																																																			
					--		activityLabel:SetText(activity)													
														
					--	end
						
					--	sta = SpellControlTab:getStatusUnit(value["name"])
					--	if sta == 3 or sta == 2 or sta == 0 then 
					--		if activity > ClassicRaidAssist.db.char.secSlaker then
					--			SpellControlTab:setStatusUnit(value["name"], 3)		
					--		else												
					--			SpellControlTab:setStatusUnit(value["name"], 2)
					--		end
					--	end						
												
					--end
																			
					if ckey ~= "Activity" then
					
						remain = math.floor(cvalue["data"] + 120 - GetTime())
													
						if remain > 0 then
							
							
							if ckey == "Восполнение маны" then 						 
								manaSpellIcon:SetImage("Interface\\Icons\\inv_potion_76")
								manaSpellLabel:SetText(remain)
							elseif ckey == "Демоническая руна" then														
								runeSpellIcon:SetImage("Interface\\Icons\\inv_misc_rune_04")
								runeSpellLabel:SetText(remain)								
							elseif ckey == "Темная руна" then						
								runeSpellIcon:SetImage("Interface\\Icons\\spell_shadow_sealofkings")
								runeSpellLabel:SetText(remain)																
							end	
							
						end
						
					end	
					
				end
			end
			
			stateLabel:SetText(SpellControlTab:getStringStatus(SpellControlTab:getStatusUnit(value["name"])))
			scrollContainer:AddChild(groupContainer)
			
		end
		
		
		
	end
	
	fullTab:AddChild(scrollContainer)
	
	container:AddChild(fullTab)
		
	if totalMax ~= 0 then 
		totalpersentage = (100*(total/totalMax))
	end
		
	container:SetStatusText(getFormatedPersentage(totalpersentage) .. string.format(" - %d/%d", total, totalMax))
	
	fullTab:SetHeight(num * 27 + 80)
	frameSpellControl:SetHeight(num * 27 + 80)
	
end

function getFormatedPersentage(persentage)

	kolor = "ff5eff00"
	if persentage < 50 then
		kolor = "fffffb00"
	end
	if persentage < 20 then
		kolor = "ffff0000"
	end	
	
	return "|c" .. kolor .. string.format("%.0f%%", persentage)
	
end

function AutoReDrowSpellFrame()

	timetoreapeat = 10
	
	if ClassicRaidAssist.db.char.spellControlHealScanMonitorEnable then
		timetoreapeat = 1
		frame:ReleaseChildren()		
		DrawSpellControlFullTab(frame)
	end
			
	C_Timer.After(timetoreapeat, AutoReDrowSpellFrame)
	
end

function SpellControlTab:AddUsedSpell(guid, spellName, amount, data, timestamp)

	if cooldowns[guid] == nil then
		cooldowns[guid] = {}
	end
	
	if cooldowns[guid][spellName] == nil then
		cooldowns[guid][spellName] = {}
	end
	
	olddata = cooldowns[guid][spellName]["data"]
	if data ~= 0 then
		olddata = data
	end
	
	cooldowns[guid][spellName] = {data = tonumber(olddata), amount = tonumber(amount), timestamp = tonumber(timestamp)}
	
end

function SpellControlTab:gethexSpell(guid, spellName, timestamp)

	result = false
	
	if cooldowns[guid] ~= nil then
		if cooldowns[guid][spellName] ~= nil then
		--print(cooldowns[guid][spellName]["timestamp"])
		--print(timestamp)
		--print(math.abs(cooldowns[guid][spellName]["timestamp"] - timestamp))
			if (math.abs(cooldowns[guid][spellName]["timestamp"] - timestamp) < 2) then
				result = true
			end 
		end
	end
	
	return result
	
end

function SpellControlTab:setStatusUnit(name, status)

	statuses[name] = status
	
end

function SpellControlTab:getStatusUnit(name)

	local sta = statuses[name]
	
	if sta == nil then
		sta = 0
	end

	return sta	
	
end

function SpellControlTab:getStringStatus(sta)

	if sta == 1 then
		return "|cff0099FFПьет"
	elseif sta == 2 then
		return "|cff33CC00Активный"
	elseif sta == 3 then
		return "|cffff0000Слакер"	
	elseif sta == 4 then
		return "|cffffff00АФК"		
	elseif sta == 0 then
		return ""
	else
		return "|cff999999Неизвестно"	
	end	
	
end

function getActivityAndSetStatus(guid, name)

	local mana = UnitPower(name, 0)

	if cooldowns[guid] == nil or cooldowns[guid]["Activity"] == nil then
		SpellControlTab:AddUsedSpell(guid, "Activity", mana, GetTime(), 0)
	end
	local oldmana = cooldowns[guid]["Activity"]["amount"];
	local activity = 0
	
	if mana < oldmana then		
		activity = 0
		SpellControlTab:AddUsedSpell(guid, "Activity", mana, GetTime(), 0)						 		
	else	
		activity = math.floor(GetTime() - cooldowns[guid]["Activity"]["data"])
		SpellControlTab:AddUsedSpell(guid, "Activity", mana, 0, 0)
		
		diff = mana - oldmana 
		if diff > ClassicRaidAssist.db.char.minManaDiff then
			AddEnergy(name, diff)
		end	
	end	

	sta = SpellControlTab:getStatusUnit(name)
	if sta == 3 or sta == 2 or sta == 0 then 
		if activity > ClassicRaidAssist.db.char.secSlaker then
			SpellControlTab:setStatusUnit(name, 3)		
		else												
			SpellControlTab:setStatusUnit(name, 2)
		end
	end
	
	if activity == 0 then
		activity = ""
	end
		
	return tostring(activity)
	
end

function AddEnergy(name, value)
	
	if tableEnegry[name] == nil then
		tableEnegry[name] = {}
	end
	
	table.insert(tableEnegry[name], {value = value, data = GetTime(), fdata = date("%H:%M:%S")})
	
	if table.maxn(tableEnegry[name]) > ClassicRaidAssist.db.char.maxNumTableEnergy then
		table.remove(tableEnegry[name], 1)
	end	
	
end

